package simulation;

class Event {
	// Constructor, creates an event of a certain type that should be put in the
	// event list at a certain time.
	Event(int type, double eventTimeStamp) throws IllegalArgumentException {
		if (type > 3 || type < 1)
			throw new IllegalArgumentException("Event type must be one of ARRIVAL, READY or MEASURE");

		eventType = type;
		eventTime = eventTimeStamp;
	}

	// Empty constructor (used by the event list constructor)
	// Event() {
	// }

	public double eventTime;
	public int eventType;
	public Event next = null; // Explicitly initialize to null
}
