package simulation;

import java.util.LinkedList;

// Essentially a linked list of a non-template node type
public class EventList {
	private Event head = null;
	private Integer size = 0;

	EventList() {
	}

	// Yes
	public Event getHead() {
		return head;
	}

	public Integer length() {
		return size;
	}

	public void insertEvent(Event newEvent) {
		if (this.head == null) {
			this.head = newEvent;
			size += 1;
			return;
		}

		Event cursor = this.head;
		// int tries = 0;
		// Find the right place in the list using a sliding window
		while ((cursor.next != null) && (cursor.eventTime < newEvent.eventTime)) {
			cursor = cursor.next;
			// tries++;
		}

		if (cursor.eventTime > newEvent.eventTime) {
			newEvent.next = this.head;
			this.head = newEvent;
		} else {
			newEvent.next = cursor.next;
			cursor.next = newEvent;
		}

		// System.out.println("Tries: " + tries);
		size += 1;
	}

	public Event popEvent() {
		if (head == null)
			return null;
		Event temp = head;
		head = head.next;
		temp.next = null;
		size -= 1;
		return temp;
	}

	public Event fetchEvent() {
		Event temp = head.next;
		head.next = temp.next;
		temp.next = null;
		size -= 1;
		return temp;
	}

	// public Event popFront() {
	// Event front = this.head;
	// this.head = this.head.next;
	// return front;
	// }
}
